/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2023 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

import {z} from "zod";

export const SchematicTypeSchema = z.object({
    name: z.string(),
    db: z.string(),
});

export type SchematicType = z.infer<typeof SchematicTypeSchema>;

export const PlayerSchema = z.object({
    id: z.number(),
    name: z.string(),
    uuid: z.string(),
    prefix: z.string(),
    perms: z.array(z.string()),
});

export type Player = z.infer<typeof PlayerSchema>;

export const ServerSchema = z.object({
    description: z.any(),
    players: z.object({
        online: z.number(),
        max: z.number(),
        sample: z.array(z.any()).optional(),
    }),
    version: z.object({
        name: z.string(),
        protocol: z.number(),
    }),
    favicon: z.string().optional(),
});

export type Server = z.infer<typeof ServerSchema>;
